This piece of makefile builds a program and runs it in order to figure out
platform-specific constants.  This doesn't work for us, so what I did here was
I built and ran it by hand on ARM linux (which happened to give the right
answers), and changed it to build these generated files statically.

--- ghc-6.10.2.orig/includes/Makefile	2009-03-31 06:13:15.000000000 +1300
+++ ghc-6.10.2/includes/Makefile	2009-06-18 15:54:37.000000000 +1200
@@ -117,23 +117,8 @@
 
 all :: DerivedConstants.h
 
-ifneq "$(TARGETPLATFORM)" "$(HOSTPLATFORM)"
-
-DerivedConstants.h :
-	@echo "*** Cross-compiling: please copy DerivedConstants.h from the target system"
-	@exit 1
-
-else
-
-mkDerivedConstants.c : $(H_CONFIG) $(H_PLATFORM)
-
-mkDerivedConstantsHdr : mkDerivedConstants.o
-	$(CC) -o $@ $(CC_OPTS) $(LD_OPTS) mkDerivedConstants.o
-
-DerivedConstants.h : mkDerivedConstantsHdr
-	./mkDerivedConstantsHdr >$@
-
-endif
+DerivedConstants.h: DerivedConstants.h.arm
+	cp $< $@
 
 CLEAN_FILES += mkDerivedConstantsHdr$(exeext) DerivedConstants.h
 
@@ -142,24 +127,8 @@
 
 all :: GHCConstants.h
 
-ifneq "$(TARGETPLATFORM)" "$(HOSTPLATFORM)"
-
-GHCConstants.h :
-	@echo "*** Cross-compiling: please copy DerivedConstants.h from the target system"
-	@exit 1
-
-else
-
-mkGHCConstants : mkGHCConstants.o
-	$(CC) -o $@ $(CC_OPTS) $(LD_OPTS) mkGHCConstants.o
-
-mkGHCConstants.o : mkDerivedConstants.c
-	$(CC) -o $@ $(CC_OPTS) -c $<  -DGEN_HASKELL
-
-GHCConstants.h : mkGHCConstants
-	./mkGHCConstants >$@
-
-endif
+GHCConstants.h: GHCConstants.h.arm
+	cp $< $@
 
 CLEAN_FILES += mkGHCConstants$(exeext) GHCConstants.h
 
--- ghc-6.10.2.orig/includes/DerivedConstants.h.arm	1970-01-01 12:00:00.000000000 +1200
+++ ghc-6.10.2/includes/DerivedConstants.h.arm	2009-06-18 15:54:37.000000000 +1200
@@ -0,0 +1,431 @@
+/* This file is created automatically.  Do not edit by hand.*/
+
+#define STD_HDR_SIZE   1
+#define PROF_HDR_SIZE  2
+#define GRAN_HDR_SIZE  1
+#define BLOCK_SIZE   4096
+#define MBLOCK_SIZE   1048576
+
+
+#define OFFSET_StgRegTable_rR1 0
+#define OFFSET_StgRegTable_rR2 4
+#define OFFSET_StgRegTable_rR3 8
+#define OFFSET_StgRegTable_rR4 12
+#define OFFSET_StgRegTable_rR5 16
+#define OFFSET_StgRegTable_rR6 20
+#define OFFSET_StgRegTable_rR7 24
+#define OFFSET_StgRegTable_rR8 28
+#define OFFSET_StgRegTable_rR9 32
+#define OFFSET_StgRegTable_rR10 36
+#define OFFSET_StgRegTable_rF1 40
+#define OFFSET_StgRegTable_rF2 44
+#define OFFSET_StgRegTable_rF3 48
+#define OFFSET_StgRegTable_rF4 52
+#define OFFSET_StgRegTable_rD1 56
+#define OFFSET_StgRegTable_rD2 64
+#define OFFSET_StgRegTable_rL1 72
+#define OFFSET_StgRegTable_rSp 80
+#define OFFSET_StgRegTable_rSpLim 84
+#define OFFSET_StgRegTable_rHp 88
+#define OFFSET_StgRegTable_rHpLim 92
+#define OFFSET_StgRegTable_rCurrentTSO 96
+#define OFFSET_StgRegTable_rCurrentNursery 104
+#define OFFSET_StgRegTable_rHpAlloc 112
+#define OFFSET_StgRegTable_rRet 176
+#define REP_StgRegTable_rRet I32
+#define StgRegTable_rRet(__ptr__)  REP_StgRegTable_rRet[__ptr__+OFFSET_StgRegTable_rRet]
+#define OFFSET_StgRegTable_rmp_tmp_w 116
+#define OFFSET_StgRegTable_rmp_tmp1 128
+#define OFFSET_StgRegTable_rmp_tmp2 140
+#define OFFSET_StgRegTable_rmp_result1 152
+#define OFFSET_StgRegTable_rmp_result2 164
+#define OFFSET_stgGCEnter1 -8
+#define OFFSET_stgGCFun -4
+#define OFFSET_Capability_r 8
+#define OFFSET_Capability_lock 240
+#define OFFSET_Capability_mut_lists 228
+#define REP_Capability_mut_lists I32
+#define Capability_mut_lists(__ptr__)  REP_Capability_mut_lists[__ptr__+OFFSET_Capability_mut_lists]
+#define OFFSET_Capability_context_switch 232
+#define REP_Capability_context_switch I32
+#define Capability_context_switch(__ptr__)  REP_Capability_context_switch[__ptr__+OFFSET_Capability_context_switch]
+#define OFFSET_bdescr_start 0
+#define REP_bdescr_start I32
+#define bdescr_start(__ptr__)  REP_bdescr_start[__ptr__+OFFSET_bdescr_start]
+#define OFFSET_bdescr_free 4
+#define REP_bdescr_free I32
+#define bdescr_free(__ptr__)  REP_bdescr_free[__ptr__+OFFSET_bdescr_free]
+#define OFFSET_bdescr_blocks 24
+#define REP_bdescr_blocks I32
+#define bdescr_blocks(__ptr__)  REP_bdescr_blocks[__ptr__+OFFSET_bdescr_blocks]
+#define OFFSET_bdescr_gen_no 16
+#define REP_bdescr_gen_no I32
+#define bdescr_gen_no(__ptr__)  REP_bdescr_gen_no[__ptr__+OFFSET_bdescr_gen_no]
+#define OFFSET_bdescr_link 8
+#define REP_bdescr_link I32
+#define bdescr_link(__ptr__)  REP_bdescr_link[__ptr__+OFFSET_bdescr_link]
+#define SIZEOF_generation 36
+#define OFFSET_generation_mut_list 16
+#define REP_generation_mut_list I32
+#define generation_mut_list(__ptr__)  REP_generation_mut_list[__ptr__+OFFSET_generation_mut_list]
+#define SIZEOF_CostCentreStack 56
+#define OFFSET_CostCentreStack_ccsID 0
+#define REP_CostCentreStack_ccsID I32
+#define CostCentreStack_ccsID(__ptr__)  REP_CostCentreStack_ccsID[__ptr__+OFFSET_CostCentreStack_ccsID]
+#define OFFSET_CostCentreStack_mem_alloc 32
+#define REP_CostCentreStack_mem_alloc I64
+#define CostCentreStack_mem_alloc(__ptr__)  REP_CostCentreStack_mem_alloc[__ptr__+OFFSET_CostCentreStack_mem_alloc]
+#define OFFSET_CostCentreStack_scc_count 16
+#define REP_CostCentreStack_scc_count I64
+#define CostCentreStack_scc_count(__ptr__)  REP_CostCentreStack_scc_count[__ptr__+OFFSET_CostCentreStack_scc_count]
+#define OFFSET_CostCentreStack_prevStack 8
+#define REP_CostCentreStack_prevStack I32
+#define CostCentreStack_prevStack(__ptr__)  REP_CostCentreStack_prevStack[__ptr__+OFFSET_CostCentreStack_prevStack]
+#define OFFSET_CostCentre_ccID 0
+#define REP_CostCentre_ccID I32
+#define CostCentre_ccID(__ptr__)  REP_CostCentre_ccID[__ptr__+OFFSET_CostCentre_ccID]
+#define OFFSET_CostCentre_link 28
+#define REP_CostCentre_link I32
+#define CostCentre_link(__ptr__)  REP_CostCentre_link[__ptr__+OFFSET_CostCentre_link]
+#define OFFSET_StgHeader_info 0
+#define REP_StgHeader_info I32
+#define StgHeader_info(__ptr__)  REP_StgHeader_info[__ptr__+OFFSET_StgHeader_info]
+#define OFFSET_StgHeader_ccs 4
+#define REP_StgHeader_ccs I32
+#define StgHeader_ccs(__ptr__)  REP_StgHeader_ccs[__ptr__+OFFSET_StgHeader_ccs]
+#define OFFSET_StgHeader_ldvw 8
+#define REP_StgHeader_ldvw I32
+#define StgHeader_ldvw(__ptr__)  REP_StgHeader_ldvw[__ptr__+OFFSET_StgHeader_ldvw]
+#define SIZEOF_StgSMPThunkHeader 4
+#define OFFSET_StgClosure_payload 0
+#define StgClosure_payload(__ptr__,__ix__)  W_[__ptr__+SIZEOF_StgHeader+OFFSET_StgClosure_payload + WDS(__ix__)]
+#define OFFSET_StgEntCounter_allocs 24
+#define REP_StgEntCounter_allocs I32
+#define StgEntCounter_allocs(__ptr__)  REP_StgEntCounter_allocs[__ptr__+OFFSET_StgEntCounter_allocs]
+#define OFFSET_StgEntCounter_registeredp 0
+#define REP_StgEntCounter_registeredp I32
+#define StgEntCounter_registeredp(__ptr__)  REP_StgEntCounter_registeredp[__ptr__+OFFSET_StgEntCounter_registeredp]
+#define OFFSET_StgEntCounter_link 28
+#define REP_StgEntCounter_link I32
+#define StgEntCounter_link(__ptr__)  REP_StgEntCounter_link[__ptr__+OFFSET_StgEntCounter_link]
+#define OFFSET_StgEntCounter_entry_count 20
+#define REP_StgEntCounter_entry_count I32
+#define StgEntCounter_entry_count(__ptr__)  REP_StgEntCounter_entry_count[__ptr__+OFFSET_StgEntCounter_entry_count]
+#define SIZEOF_StgUpdateFrame_NoHdr 4
+#define SIZEOF_StgUpdateFrame (SIZEOF_StgHeader+4)
+#define SIZEOF_StgCatchFrame_NoHdr 8
+#define SIZEOF_StgCatchFrame (SIZEOF_StgHeader+8)
+#define SIZEOF_StgStopFrame_NoHdr 0
+#define SIZEOF_StgStopFrame (SIZEOF_StgHeader+0)
+#define SIZEOF_StgMutArrPtrs_NoHdr 4
+#define SIZEOF_StgMutArrPtrs (SIZEOF_StgHeader+4)
+#define OFFSET_StgMutArrPtrs_ptrs 0
+#define REP_StgMutArrPtrs_ptrs I32
+#define StgMutArrPtrs_ptrs(__ptr__)  REP_StgMutArrPtrs_ptrs[__ptr__+SIZEOF_StgHeader+OFFSET_StgMutArrPtrs_ptrs]
+#define SIZEOF_StgArrWords_NoHdr 4
+#define SIZEOF_StgArrWords (SIZEOF_StgHeader+4)
+#define OFFSET_StgArrWords_words 0
+#define REP_StgArrWords_words I32
+#define StgArrWords_words(__ptr__)  REP_StgArrWords_words[__ptr__+SIZEOF_StgHeader+OFFSET_StgArrWords_words]
+#define OFFSET_StgArrWords_payload 4
+#define StgArrWords_payload(__ptr__,__ix__)  W_[__ptr__+SIZEOF_StgHeader+OFFSET_StgArrWords_payload + WDS(__ix__)]
+#define OFFSET_StgTSO__link 0
+#define REP_StgTSO__link I32
+#define StgTSO__link(__ptr__)  REP_StgTSO__link[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO__link]
+#define OFFSET_StgTSO_global_link 4
+#define REP_StgTSO_global_link I32
+#define StgTSO_global_link(__ptr__)  REP_StgTSO_global_link[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_global_link]
+#define OFFSET_StgTSO_what_next 8
+#define REP_StgTSO_what_next I16
+#define StgTSO_what_next(__ptr__)  REP_StgTSO_what_next[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_what_next]
+#define OFFSET_StgTSO_why_blocked 10
+#define REP_StgTSO_why_blocked I16
+#define StgTSO_why_blocked(__ptr__)  REP_StgTSO_why_blocked[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_why_blocked]
+#define OFFSET_StgTSO_block_info 16
+#define REP_StgTSO_block_info I32
+#define StgTSO_block_info(__ptr__)  REP_StgTSO_block_info[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_block_info]
+#define OFFSET_StgTSO_blocked_exceptions 40
+#define REP_StgTSO_blocked_exceptions I32
+#define StgTSO_blocked_exceptions(__ptr__)  REP_StgTSO_blocked_exceptions[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_blocked_exceptions]
+#define OFFSET_StgTSO_id 20
+#define REP_StgTSO_id I32
+#define StgTSO_id(__ptr__)  REP_StgTSO_id[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_id]
+#define OFFSET_StgTSO_cap 32
+#define REP_StgTSO_cap I32
+#define StgTSO_cap(__ptr__)  REP_StgTSO_cap[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_cap]
+#define OFFSET_StgTSO_saved_errno 24
+#define REP_StgTSO_saved_errno I32
+#define StgTSO_saved_errno(__ptr__)  REP_StgTSO_saved_errno[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_saved_errno]
+#define OFFSET_StgTSO_trec 36
+#define REP_StgTSO_trec I32
+#define StgTSO_trec(__ptr__)  REP_StgTSO_trec[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_trec]
+#define OFFSET_StgTSO_flags 12
+#define REP_StgTSO_flags I32
+#define StgTSO_flags(__ptr__)  REP_StgTSO_flags[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_flags]
+#define OFFSET_StgTSO_CCCS 44
+#define REP_StgTSO_CCCS I32
+#define StgTSO_CCCS(__ptr__)  REP_StgTSO_CCCS[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_CCCS]
+#define REP_StgTSO_sp I32
+#define OFFSET_StgTSO_sp 52
+#define TSO_OFFSET_StgTSO_sp (SIZEOF_StgHeader+SIZEOF_OPT_StgTSOProfInfo+SIZEOF_OPT_StgTSOParInfo+SIZEOF_OPT_StgTSOGranInfo+SIZEOF_OPT_StgTSODistInfo+OFFSET_StgTSO_sp)
+#define StgTSO_sp(__ptr__)  REP_StgTSO_sp[__ptr__+TSO_OFFSET_StgTSO_sp]
+#define OFFSET_StgTSO_stack 56
+#define TSO_OFFSET_StgTSO_stack (SIZEOF_StgHeader+SIZEOF_OPT_StgTSOProfInfo+SIZEOF_OPT_StgTSOParInfo+SIZEOF_OPT_StgTSOGranInfo+SIZEOF_OPT_StgTSODistInfo+OFFSET_StgTSO_stack)
+#define REP_StgTSO_stack_size I32
+#define OFFSET_StgTSO_stack_size 44
+#define TSO_OFFSET_StgTSO_stack_size (SIZEOF_StgHeader+SIZEOF_OPT_StgTSOProfInfo+SIZEOF_OPT_StgTSOParInfo+SIZEOF_OPT_StgTSOGranInfo+SIZEOF_OPT_StgTSODistInfo+OFFSET_StgTSO_stack_size)
+#define StgTSO_stack_size(__ptr__)  REP_StgTSO_stack_size[__ptr__+TSO_OFFSET_StgTSO_stack_size]
+#define SIZEOF_StgTSOProfInfo 4
+#define SIZEOF_StgTSOParInfo 92
+#define SIZEOF_StgTSOGranInfo 92
+#define SIZEOF_StgTSODistInfo 12
+#ifdef PROFILING
+#define SIZEOF_OPT_StgTSOProfInfo SIZEOF_StgTSOProfInfo
+#else
+#define SIZEOF_OPT_StgTSOProfInfo 0
+#endif
+
+#ifdef PAR
+#define SIZEOF_OPT_StgTSOParInfo SIZEOF_StgTSOParInfo
+#else
+#define SIZEOF_OPT_StgTSOParInfo 0
+#endif
+
+#ifdef GRAN
+#define SIZEOF_OPT_StgTSOGranInfo SIZEOF_StgTSOGranInfo
+#else
+#define SIZEOF_OPT_StgTSOGranInfo 0
+#endif
+
+#ifdef DIST
+#define SIZEOF_OPT_StgTSODistInfo SIZEOF_StgTSODistInfo
+#else
+#define SIZEOF_OPT_StgTSODistInfo 0
+#endif
+
+#define OFFSET_StgUpdateFrame_updatee 0
+#define REP_StgUpdateFrame_updatee I32
+#define StgUpdateFrame_updatee(__ptr__)  REP_StgUpdateFrame_updatee[__ptr__+SIZEOF_StgHeader+OFFSET_StgUpdateFrame_updatee]
+#define OFFSET_StgCatchFrame_handler 4
+#define REP_StgCatchFrame_handler I32
+#define StgCatchFrame_handler(__ptr__)  REP_StgCatchFrame_handler[__ptr__+SIZEOF_StgHeader+OFFSET_StgCatchFrame_handler]
+#define OFFSET_StgCatchFrame_exceptions_blocked 0
+#define REP_StgCatchFrame_exceptions_blocked I32
+#define StgCatchFrame_exceptions_blocked(__ptr__)  REP_StgCatchFrame_exceptions_blocked[__ptr__+SIZEOF_StgHeader+OFFSET_StgCatchFrame_exceptions_blocked]
+#define SIZEOF_StgPAP_NoHdr 8
+#define SIZEOF_StgPAP (SIZEOF_StgHeader+8)
+#define OFFSET_StgPAP_n_args 2
+#define REP_StgPAP_n_args I16
+#define StgPAP_n_args(__ptr__)  REP_StgPAP_n_args[__ptr__+SIZEOF_StgHeader+OFFSET_StgPAP_n_args]
+#define OFFSET_StgPAP_fun 4
+#define REP_StgPAP_fun I32
+#define StgPAP_fun(__ptr__)  REP_StgPAP_fun[__ptr__+SIZEOF_StgHeader+OFFSET_StgPAP_fun]
+#define OFFSET_StgPAP_arity 0
+#define REP_StgPAP_arity I16
+#define StgPAP_arity(__ptr__)  REP_StgPAP_arity[__ptr__+SIZEOF_StgHeader+OFFSET_StgPAP_arity]
+#define OFFSET_StgPAP_payload 8
+#define StgPAP_payload(__ptr__,__ix__)  W_[__ptr__+SIZEOF_StgHeader+OFFSET_StgPAP_payload + WDS(__ix__)]
+#define SIZEOF_StgAP_NoThunkHdr 8
+#define SIZEOF_StgAP_NoHdr 12
+#define SIZEOF_StgAP (SIZEOF_StgHeader+12)
+#define OFFSET_StgAP_n_args 6
+#define REP_StgAP_n_args I16
+#define StgAP_n_args(__ptr__)  REP_StgAP_n_args[__ptr__+SIZEOF_StgHeader+OFFSET_StgAP_n_args]
+#define OFFSET_StgAP_fun 8
+#define REP_StgAP_fun I32
+#define StgAP_fun(__ptr__)  REP_StgAP_fun[__ptr__+SIZEOF_StgHeader+OFFSET_StgAP_fun]
+#define OFFSET_StgAP_payload 12
+#define StgAP_payload(__ptr__,__ix__)  W_[__ptr__+SIZEOF_StgHeader+OFFSET_StgAP_payload + WDS(__ix__)]
+#define SIZEOF_StgAP_STACK_NoThunkHdr 8
+#define SIZEOF_StgAP_STACK_NoHdr 12
+#define SIZEOF_StgAP_STACK (SIZEOF_StgHeader+12)
+#define OFFSET_StgAP_STACK_size 4
+#define REP_StgAP_STACK_size I32
+#define StgAP_STACK_size(__ptr__)  REP_StgAP_STACK_size[__ptr__+SIZEOF_StgHeader+OFFSET_StgAP_STACK_size]
+#define OFFSET_StgAP_STACK_fun 8
+#define REP_StgAP_STACK_fun I32
+#define StgAP_STACK_fun(__ptr__)  REP_StgAP_STACK_fun[__ptr__+SIZEOF_StgHeader+OFFSET_StgAP_STACK_fun]
+#define OFFSET_StgAP_STACK_payload 12
+#define StgAP_STACK_payload(__ptr__,__ix__)  W_[__ptr__+SIZEOF_StgHeader+OFFSET_StgAP_STACK_payload + WDS(__ix__)]
+#define SIZEOF_StgSelector_NoThunkHdr 4
+#define SIZEOF_StgSelector_NoHdr 8
+#define SIZEOF_StgSelector (SIZEOF_StgHeader+8)
+#define OFFSET_StgInd_indirectee 0
+#define REP_StgInd_indirectee I32
+#define StgInd_indirectee(__ptr__)  REP_StgInd_indirectee[__ptr__+SIZEOF_StgHeader+OFFSET_StgInd_indirectee]
+#define SIZEOF_StgMutVar_NoHdr 4
+#define SIZEOF_StgMutVar (SIZEOF_StgHeader+4)
+#define OFFSET_StgMutVar_var 0
+#define REP_StgMutVar_var I32
+#define StgMutVar_var(__ptr__)  REP_StgMutVar_var[__ptr__+SIZEOF_StgHeader+OFFSET_StgMutVar_var]
+#define SIZEOF_StgAtomicallyFrame_NoHdr 8
+#define SIZEOF_StgAtomicallyFrame (SIZEOF_StgHeader+8)
+#define OFFSET_StgAtomicallyFrame_code 0
+#define REP_StgAtomicallyFrame_code I32
+#define StgAtomicallyFrame_code(__ptr__)  REP_StgAtomicallyFrame_code[__ptr__+SIZEOF_StgHeader+OFFSET_StgAtomicallyFrame_code]
+#define OFFSET_StgAtomicallyFrame_next_invariant_to_check 4
+#define REP_StgAtomicallyFrame_next_invariant_to_check I32
+#define StgAtomicallyFrame_next_invariant_to_check(__ptr__)  REP_StgAtomicallyFrame_next_invariant_to_check[__ptr__+SIZEOF_StgHeader+OFFSET_StgAtomicallyFrame_next_invariant_to_check]
+#define OFFSET_StgInvariantCheckQueue_invariant 0
+#define REP_StgInvariantCheckQueue_invariant I32
+#define StgInvariantCheckQueue_invariant(__ptr__)  REP_StgInvariantCheckQueue_invariant[__ptr__+SIZEOF_StgHeader+OFFSET_StgInvariantCheckQueue_invariant]
+#define OFFSET_StgInvariantCheckQueue_my_execution 4
+#define REP_StgInvariantCheckQueue_my_execution I32
+#define StgInvariantCheckQueue_my_execution(__ptr__)  REP_StgInvariantCheckQueue_my_execution[__ptr__+SIZEOF_StgHeader+OFFSET_StgInvariantCheckQueue_my_execution]
+#define OFFSET_StgInvariantCheckQueue_next_queue_entry 8
+#define REP_StgInvariantCheckQueue_next_queue_entry I32
+#define StgInvariantCheckQueue_next_queue_entry(__ptr__)  REP_StgInvariantCheckQueue_next_queue_entry[__ptr__+SIZEOF_StgHeader+OFFSET_StgInvariantCheckQueue_next_queue_entry]
+#define OFFSET_StgAtomicInvariant_code 0
+#define REP_StgAtomicInvariant_code I32
+#define StgAtomicInvariant_code(__ptr__)  REP_StgAtomicInvariant_code[__ptr__+SIZEOF_StgHeader+OFFSET_StgAtomicInvariant_code]
+#define SIZEOF_StgCatchSTMFrame_NoHdr 8
+#define SIZEOF_StgCatchSTMFrame (SIZEOF_StgHeader+8)
+#define OFFSET_StgCatchSTMFrame_handler 4
+#define REP_StgCatchSTMFrame_handler I32
+#define StgCatchSTMFrame_handler(__ptr__)  REP_StgCatchSTMFrame_handler[__ptr__+SIZEOF_StgHeader+OFFSET_StgCatchSTMFrame_handler]
+#define OFFSET_StgCatchSTMFrame_code 0
+#define REP_StgCatchSTMFrame_code I32
+#define StgCatchSTMFrame_code(__ptr__)  REP_StgCatchSTMFrame_code[__ptr__+SIZEOF_StgHeader+OFFSET_StgCatchSTMFrame_code]
+#define SIZEOF_StgCatchRetryFrame_NoHdr 12
+#define SIZEOF_StgCatchRetryFrame (SIZEOF_StgHeader+12)
+#define OFFSET_StgCatchRetryFrame_running_alt_code 0
+#define REP_StgCatchRetryFrame_running_alt_code I32
+#define StgCatchRetryFrame_running_alt_code(__ptr__)  REP_StgCatchRetryFrame_running_alt_code[__ptr__+SIZEOF_StgHeader+OFFSET_StgCatchRetryFrame_running_alt_code]
+#define OFFSET_StgCatchRetryFrame_first_code 4
+#define REP_StgCatchRetryFrame_first_code I32
+#define StgCatchRetryFrame_first_code(__ptr__)  REP_StgCatchRetryFrame_first_code[__ptr__+SIZEOF_StgHeader+OFFSET_StgCatchRetryFrame_first_code]
+#define OFFSET_StgCatchRetryFrame_alt_code 8
+#define REP_StgCatchRetryFrame_alt_code I32
+#define StgCatchRetryFrame_alt_code(__ptr__)  REP_StgCatchRetryFrame_alt_code[__ptr__+SIZEOF_StgHeader+OFFSET_StgCatchRetryFrame_alt_code]
+#define OFFSET_StgTVarWatchQueue_closure 0
+#define REP_StgTVarWatchQueue_closure I32
+#define StgTVarWatchQueue_closure(__ptr__)  REP_StgTVarWatchQueue_closure[__ptr__+SIZEOF_StgHeader+OFFSET_StgTVarWatchQueue_closure]
+#define OFFSET_StgTVarWatchQueue_next_queue_entry 4
+#define REP_StgTVarWatchQueue_next_queue_entry I32
+#define StgTVarWatchQueue_next_queue_entry(__ptr__)  REP_StgTVarWatchQueue_next_queue_entry[__ptr__+SIZEOF_StgHeader+OFFSET_StgTVarWatchQueue_next_queue_entry]
+#define OFFSET_StgTVarWatchQueue_prev_queue_entry 8
+#define REP_StgTVarWatchQueue_prev_queue_entry I32
+#define StgTVarWatchQueue_prev_queue_entry(__ptr__)  REP_StgTVarWatchQueue_prev_queue_entry[__ptr__+SIZEOF_StgHeader+OFFSET_StgTVarWatchQueue_prev_queue_entry]
+#define SIZEOF_StgWeak_NoHdr 20
+#define SIZEOF_StgWeak (SIZEOF_StgHeader+20)
+#define OFFSET_StgWeak_link 16
+#define REP_StgWeak_link I32
+#define StgWeak_link(__ptr__)  REP_StgWeak_link[__ptr__+SIZEOF_StgHeader+OFFSET_StgWeak_link]
+#define OFFSET_StgWeak_key 4
+#define REP_StgWeak_key I32
+#define StgWeak_key(__ptr__)  REP_StgWeak_key[__ptr__+SIZEOF_StgHeader+OFFSET_StgWeak_key]
+#define OFFSET_StgWeak_value 8
+#define REP_StgWeak_value I32
+#define StgWeak_value(__ptr__)  REP_StgWeak_value[__ptr__+SIZEOF_StgHeader+OFFSET_StgWeak_value]
+#define OFFSET_StgWeak_finalizer 12
+#define REP_StgWeak_finalizer I32
+#define StgWeak_finalizer(__ptr__)  REP_StgWeak_finalizer[__ptr__+SIZEOF_StgHeader+OFFSET_StgWeak_finalizer]
+#define OFFSET_StgWeak_cfinalizer 0
+#define REP_StgWeak_cfinalizer I32
+#define StgWeak_cfinalizer(__ptr__)  REP_StgWeak_cfinalizer[__ptr__+SIZEOF_StgHeader+OFFSET_StgWeak_cfinalizer]
+#define SIZEOF_StgDeadWeak_NoHdr 4
+#define SIZEOF_StgDeadWeak (SIZEOF_StgHeader+4)
+#define OFFSET_StgDeadWeak_link 0
+#define REP_StgDeadWeak_link I32
+#define StgDeadWeak_link(__ptr__)  REP_StgDeadWeak_link[__ptr__+SIZEOF_StgHeader+OFFSET_StgDeadWeak_link]
+#define SIZEOF_StgMVar_NoHdr 12
+#define SIZEOF_StgMVar (SIZEOF_StgHeader+12)
+#define OFFSET_StgMVar_head 0
+#define REP_StgMVar_head I32
+#define StgMVar_head(__ptr__)  REP_StgMVar_head[__ptr__+SIZEOF_StgHeader+OFFSET_StgMVar_head]
+#define OFFSET_StgMVar_tail 4
+#define REP_StgMVar_tail I32
+#define StgMVar_tail(__ptr__)  REP_StgMVar_tail[__ptr__+SIZEOF_StgHeader+OFFSET_StgMVar_tail]
+#define OFFSET_StgMVar_value 8
+#define REP_StgMVar_value I32
+#define StgMVar_value(__ptr__)  REP_StgMVar_value[__ptr__+SIZEOF_StgHeader+OFFSET_StgMVar_value]
+#define SIZEOF_StgBCO_NoHdr 16
+#define SIZEOF_StgBCO (SIZEOF_StgHeader+16)
+#define OFFSET_StgBCO_instrs 0
+#define REP_StgBCO_instrs I32
+#define StgBCO_instrs(__ptr__)  REP_StgBCO_instrs[__ptr__+SIZEOF_StgHeader+OFFSET_StgBCO_instrs]
+#define OFFSET_StgBCO_literals 4
+#define REP_StgBCO_literals I32
+#define StgBCO_literals(__ptr__)  REP_StgBCO_literals[__ptr__+SIZEOF_StgHeader+OFFSET_StgBCO_literals]
+#define OFFSET_StgBCO_ptrs 8
+#define REP_StgBCO_ptrs I32
+#define StgBCO_ptrs(__ptr__)  REP_StgBCO_ptrs[__ptr__+SIZEOF_StgHeader+OFFSET_StgBCO_ptrs]
+#define OFFSET_StgBCO_arity 12
+#define REP_StgBCO_arity I16
+#define StgBCO_arity(__ptr__)  REP_StgBCO_arity[__ptr__+SIZEOF_StgHeader+OFFSET_StgBCO_arity]
+#define OFFSET_StgBCO_size 14
+#define REP_StgBCO_size I16
+#define StgBCO_size(__ptr__)  REP_StgBCO_size[__ptr__+SIZEOF_StgHeader+OFFSET_StgBCO_size]
+#define OFFSET_StgBCO_bitmap 16
+#define StgBCO_bitmap(__ptr__,__ix__)  W_[__ptr__+SIZEOF_StgHeader+OFFSET_StgBCO_bitmap + WDS(__ix__)]
+#define SIZEOF_StgStableName_NoHdr 4
+#define SIZEOF_StgStableName (SIZEOF_StgHeader+4)
+#define OFFSET_StgStableName_sn 0
+#define REP_StgStableName_sn I32
+#define StgStableName_sn(__ptr__)  REP_StgStableName_sn[__ptr__+SIZEOF_StgHeader+OFFSET_StgStableName_sn]
+#define OFFSET_RtsFlags_ProfFlags_showCCSOnException 208
+#define REP_RtsFlags_ProfFlags_showCCSOnException I32
+#define RtsFlags_ProfFlags_showCCSOnException(__ptr__)  REP_RtsFlags_ProfFlags_showCCSOnException[__ptr__+OFFSET_RtsFlags_ProfFlags_showCCSOnException]
+#define OFFSET_RtsFlags_DebugFlags_apply 164
+#define REP_RtsFlags_DebugFlags_apply I32
+#define RtsFlags_DebugFlags_apply(__ptr__)  REP_RtsFlags_DebugFlags_apply[__ptr__+OFFSET_RtsFlags_DebugFlags_apply]
+#define OFFSET_RtsFlags_DebugFlags_sanity 140
+#define REP_RtsFlags_DebugFlags_sanity I32
+#define RtsFlags_DebugFlags_sanity(__ptr__)  REP_RtsFlags_DebugFlags_sanity[__ptr__+OFFSET_RtsFlags_DebugFlags_sanity]
+#define OFFSET_RtsFlags_DebugFlags_weak 124
+#define REP_RtsFlags_DebugFlags_weak I32
+#define RtsFlags_DebugFlags_weak(__ptr__)  REP_RtsFlags_DebugFlags_weak[__ptr__+OFFSET_RtsFlags_DebugFlags_weak]
+#define OFFSET_RtsFlags_GcFlags_initialStkSize 12
+#define REP_RtsFlags_GcFlags_initialStkSize I32
+#define RtsFlags_GcFlags_initialStkSize(__ptr__)  REP_RtsFlags_GcFlags_initialStkSize[__ptr__+OFFSET_RtsFlags_GcFlags_initialStkSize]
+#define OFFSET_RtsFlags_MiscFlags_tickInterval 100
+#define REP_RtsFlags_MiscFlags_tickInterval I32
+#define RtsFlags_MiscFlags_tickInterval(__ptr__)  REP_RtsFlags_MiscFlags_tickInterval[__ptr__+OFFSET_RtsFlags_MiscFlags_tickInterval]
+#define SIZEOF_StgFunInfoExtraFwd 16
+#define OFFSET_StgFunInfoExtraFwd_slow_apply 12
+#define REP_StgFunInfoExtraFwd_slow_apply I32
+#define StgFunInfoExtraFwd_slow_apply(__ptr__)  REP_StgFunInfoExtraFwd_slow_apply[__ptr__+OFFSET_StgFunInfoExtraFwd_slow_apply]
+#define OFFSET_StgFunInfoExtraFwd_fun_type 0
+#define REP_StgFunInfoExtraFwd_fun_type I16
+#define StgFunInfoExtraFwd_fun_type(__ptr__)  REP_StgFunInfoExtraFwd_fun_type[__ptr__+OFFSET_StgFunInfoExtraFwd_fun_type]
+#define OFFSET_StgFunInfoExtraFwd_arity 2
+#define REP_StgFunInfoExtraFwd_arity I16
+#define StgFunInfoExtraFwd_arity(__ptr__)  REP_StgFunInfoExtraFwd_arity[__ptr__+OFFSET_StgFunInfoExtraFwd_arity]
+#define OFFSET_StgFunInfoExtraFwd_bitmap 8
+#define REP_StgFunInfoExtraFwd_bitmap I32
+#define StgFunInfoExtraFwd_bitmap(__ptr__)  REP_StgFunInfoExtraFwd_bitmap[__ptr__+OFFSET_StgFunInfoExtraFwd_bitmap]
+#define SIZEOF_StgFunInfoExtraRev 16
+#define OFFSET_StgFunInfoExtraRev_slow_apply_offset 0
+#define REP_StgFunInfoExtraRev_slow_apply_offset I32
+#define StgFunInfoExtraRev_slow_apply_offset(__ptr__)  REP_StgFunInfoExtraRev_slow_apply_offset[__ptr__+OFFSET_StgFunInfoExtraRev_slow_apply_offset]
+#define OFFSET_StgFunInfoExtraRev_fun_type 12
+#define REP_StgFunInfoExtraRev_fun_type I16
+#define StgFunInfoExtraRev_fun_type(__ptr__)  REP_StgFunInfoExtraRev_fun_type[__ptr__+OFFSET_StgFunInfoExtraRev_fun_type]
+#define OFFSET_StgFunInfoExtraRev_arity 14
+#define REP_StgFunInfoExtraRev_arity I16
+#define StgFunInfoExtraRev_arity(__ptr__)  REP_StgFunInfoExtraRev_arity[__ptr__+OFFSET_StgFunInfoExtraRev_arity]
+#define OFFSET_StgFunInfoExtraRev_bitmap 4
+#define REP_StgFunInfoExtraRev_bitmap I32
+#define StgFunInfoExtraRev_bitmap(__ptr__)  REP_StgFunInfoExtraRev_bitmap[__ptr__+OFFSET_StgFunInfoExtraRev_bitmap]
+#define OFFSET_StgLargeBitmap_size 0
+#define REP_StgLargeBitmap_size I32
+#define StgLargeBitmap_size(__ptr__)  REP_StgLargeBitmap_size[__ptr__+OFFSET_StgLargeBitmap_size]
+#define OFFSET_StgLargeBitmap_bitmap 4
+#define SIZEOF_snEntry 16
+#define OFFSET_snEntry_sn_obj 12
+#define REP_snEntry_sn_obj I32
+#define snEntry_sn_obj(__ptr__)  REP_snEntry_sn_obj[__ptr__+OFFSET_snEntry_sn_obj]
+#define OFFSET_snEntry_addr 0
+#define REP_snEntry_addr I32
+#define snEntry_addr(__ptr__)  REP_snEntry_addr[__ptr__+OFFSET_snEntry_addr]
+#define SIZEOF_MP_INT 12
+#define OFFSET_MP_INT__mp_alloc 0
+#define REP_MP_INT__mp_alloc I32
+#define MP_INT__mp_alloc(__ptr__)  REP_MP_INT__mp_alloc[__ptr__+OFFSET_MP_INT__mp_alloc]
+#define OFFSET_MP_INT__mp_size 4
+#define REP_MP_INT__mp_size I32
+#define MP_INT__mp_size(__ptr__)  REP_MP_INT__mp_size[__ptr__+OFFSET_MP_INT__mp_size]
+#define OFFSET_MP_INT__mp_d 8
+#define REP_MP_INT__mp_d I32
+#define MP_INT__mp_d(__ptr__)  REP_MP_INT__mp_d[__ptr__+OFFSET_MP_INT__mp_d]
+#define SIZEOF_mp_limb_t 4
--- ghc-6.10.2.orig/includes/GHCConstants.h.arm	1970-01-01 12:00:00.000000000 +1200
+++ ghc-6.10.2/includes/GHCConstants.h.arm	2009-06-18 15:54:37.000000000 +1200
@@ -0,0 +1,476 @@
+oFFSET_StgRegTable_rR1 :: Int
+oFFSET_StgRegTable_rR1 = 0
+oFFSET_StgRegTable_rR2 :: Int
+oFFSET_StgRegTable_rR2 = 4
+oFFSET_StgRegTable_rR3 :: Int
+oFFSET_StgRegTable_rR3 = 8
+oFFSET_StgRegTable_rR4 :: Int
+oFFSET_StgRegTable_rR4 = 12
+oFFSET_StgRegTable_rR5 :: Int
+oFFSET_StgRegTable_rR5 = 16
+oFFSET_StgRegTable_rR6 :: Int
+oFFSET_StgRegTable_rR6 = 20
+oFFSET_StgRegTable_rR7 :: Int
+oFFSET_StgRegTable_rR7 = 24
+oFFSET_StgRegTable_rR8 :: Int
+oFFSET_StgRegTable_rR8 = 28
+oFFSET_StgRegTable_rR9 :: Int
+oFFSET_StgRegTable_rR9 = 32
+oFFSET_StgRegTable_rR10 :: Int
+oFFSET_StgRegTable_rR10 = 36
+oFFSET_StgRegTable_rF1 :: Int
+oFFSET_StgRegTable_rF1 = 40
+oFFSET_StgRegTable_rF2 :: Int
+oFFSET_StgRegTable_rF2 = 44
+oFFSET_StgRegTable_rF3 :: Int
+oFFSET_StgRegTable_rF3 = 48
+oFFSET_StgRegTable_rF4 :: Int
+oFFSET_StgRegTable_rF4 = 52
+oFFSET_StgRegTable_rD1 :: Int
+oFFSET_StgRegTable_rD1 = 56
+oFFSET_StgRegTable_rD2 :: Int
+oFFSET_StgRegTable_rD2 = 64
+oFFSET_StgRegTable_rL1 :: Int
+oFFSET_StgRegTable_rL1 = 72
+oFFSET_StgRegTable_rSp :: Int
+oFFSET_StgRegTable_rSp = 80
+oFFSET_StgRegTable_rSpLim :: Int
+oFFSET_StgRegTable_rSpLim = 84
+oFFSET_StgRegTable_rHp :: Int
+oFFSET_StgRegTable_rHp = 88
+oFFSET_StgRegTable_rHpLim :: Int
+oFFSET_StgRegTable_rHpLim = 92
+oFFSET_StgRegTable_rCurrentTSO :: Int
+oFFSET_StgRegTable_rCurrentTSO = 96
+oFFSET_StgRegTable_rCurrentNursery :: Int
+oFFSET_StgRegTable_rCurrentNursery = 104
+oFFSET_StgRegTable_rHpAlloc :: Int
+oFFSET_StgRegTable_rHpAlloc = 112
+oFFSET_StgRegTable_rRet :: Int
+oFFSET_StgRegTable_rRet = 176
+#define StgRegTable_rRet(__ptr__)  REP_StgRegTable_rRet[__ptr__+OFFSET_StgRegTable_rRet]
+oFFSET_StgRegTable_rmp_tmp_w :: Int
+oFFSET_StgRegTable_rmp_tmp_w = 116
+oFFSET_StgRegTable_rmp_tmp1 :: Int
+oFFSET_StgRegTable_rmp_tmp1 = 128
+oFFSET_StgRegTable_rmp_tmp2 :: Int
+oFFSET_StgRegTable_rmp_tmp2 = 140
+oFFSET_StgRegTable_rmp_result1 :: Int
+oFFSET_StgRegTable_rmp_result1 = 152
+oFFSET_StgRegTable_rmp_result2 :: Int
+oFFSET_StgRegTable_rmp_result2 = 164
+oFFSET_stgGCEnter1 :: Int
+oFFSET_stgGCEnter1 = -8
+oFFSET_stgGCFun :: Int
+oFFSET_stgGCFun = -4
+oFFSET_Capability_r :: Int
+oFFSET_Capability_r = 8
+oFFSET_Capability_lock :: Int
+oFFSET_Capability_lock = 240
+oFFSET_Capability_mut_lists :: Int
+oFFSET_Capability_mut_lists = 228
+#define Capability_mut_lists(__ptr__)  REP_Capability_mut_lists[__ptr__+OFFSET_Capability_mut_lists]
+oFFSET_Capability_context_switch :: Int
+oFFSET_Capability_context_switch = 232
+#define Capability_context_switch(__ptr__)  REP_Capability_context_switch[__ptr__+OFFSET_Capability_context_switch]
+oFFSET_bdescr_start :: Int
+oFFSET_bdescr_start = 0
+#define bdescr_start(__ptr__)  REP_bdescr_start[__ptr__+OFFSET_bdescr_start]
+oFFSET_bdescr_free :: Int
+oFFSET_bdescr_free = 4
+#define bdescr_free(__ptr__)  REP_bdescr_free[__ptr__+OFFSET_bdescr_free]
+oFFSET_bdescr_blocks :: Int
+oFFSET_bdescr_blocks = 24
+#define bdescr_blocks(__ptr__)  REP_bdescr_blocks[__ptr__+OFFSET_bdescr_blocks]
+oFFSET_bdescr_gen_no :: Int
+oFFSET_bdescr_gen_no = 16
+#define bdescr_gen_no(__ptr__)  REP_bdescr_gen_no[__ptr__+OFFSET_bdescr_gen_no]
+oFFSET_bdescr_link :: Int
+oFFSET_bdescr_link = 8
+#define bdescr_link(__ptr__)  REP_bdescr_link[__ptr__+OFFSET_bdescr_link]
+sIZEOF_generation :: Int
+sIZEOF_generation = 36
+oFFSET_generation_mut_list :: Int
+oFFSET_generation_mut_list = 16
+#define generation_mut_list(__ptr__)  REP_generation_mut_list[__ptr__+OFFSET_generation_mut_list]
+sIZEOF_CostCentreStack :: Int
+sIZEOF_CostCentreStack = 56
+oFFSET_CostCentreStack_ccsID :: Int
+oFFSET_CostCentreStack_ccsID = 0
+#define CostCentreStack_ccsID(__ptr__)  REP_CostCentreStack_ccsID[__ptr__+OFFSET_CostCentreStack_ccsID]
+oFFSET_CostCentreStack_mem_alloc :: Int
+oFFSET_CostCentreStack_mem_alloc = 32
+#define CostCentreStack_mem_alloc(__ptr__)  REP_CostCentreStack_mem_alloc[__ptr__+OFFSET_CostCentreStack_mem_alloc]
+oFFSET_CostCentreStack_scc_count :: Int
+oFFSET_CostCentreStack_scc_count = 16
+#define CostCentreStack_scc_count(__ptr__)  REP_CostCentreStack_scc_count[__ptr__+OFFSET_CostCentreStack_scc_count]
+oFFSET_CostCentreStack_prevStack :: Int
+oFFSET_CostCentreStack_prevStack = 8
+#define CostCentreStack_prevStack(__ptr__)  REP_CostCentreStack_prevStack[__ptr__+OFFSET_CostCentreStack_prevStack]
+oFFSET_CostCentre_ccID :: Int
+oFFSET_CostCentre_ccID = 0
+#define CostCentre_ccID(__ptr__)  REP_CostCentre_ccID[__ptr__+OFFSET_CostCentre_ccID]
+oFFSET_CostCentre_link :: Int
+oFFSET_CostCentre_link = 28
+#define CostCentre_link(__ptr__)  REP_CostCentre_link[__ptr__+OFFSET_CostCentre_link]
+oFFSET_StgHeader_info :: Int
+oFFSET_StgHeader_info = 0
+#define StgHeader_info(__ptr__)  REP_StgHeader_info[__ptr__+OFFSET_StgHeader_info]
+oFFSET_StgHeader_ccs :: Int
+oFFSET_StgHeader_ccs = 4
+#define StgHeader_ccs(__ptr__)  REP_StgHeader_ccs[__ptr__+OFFSET_StgHeader_ccs]
+oFFSET_StgHeader_ldvw :: Int
+oFFSET_StgHeader_ldvw = 8
+#define StgHeader_ldvw(__ptr__)  REP_StgHeader_ldvw[__ptr__+OFFSET_StgHeader_ldvw]
+sIZEOF_StgSMPThunkHeader :: Int
+sIZEOF_StgSMPThunkHeader = 4
+oFFSET_StgClosure_payload :: Int
+oFFSET_StgClosure_payload = 0
+#define StgClosure_payload(__ptr__,__ix__)  W_[__ptr__+SIZEOF_StgHeader+OFFSET_StgClosure_payload + WDS(__ix__)]
+oFFSET_StgEntCounter_allocs :: Int
+oFFSET_StgEntCounter_allocs = 24
+#define StgEntCounter_allocs(__ptr__)  REP_StgEntCounter_allocs[__ptr__+OFFSET_StgEntCounter_allocs]
+oFFSET_StgEntCounter_registeredp :: Int
+oFFSET_StgEntCounter_registeredp = 0
+#define StgEntCounter_registeredp(__ptr__)  REP_StgEntCounter_registeredp[__ptr__+OFFSET_StgEntCounter_registeredp]
+oFFSET_StgEntCounter_link :: Int
+oFFSET_StgEntCounter_link = 28
+#define StgEntCounter_link(__ptr__)  REP_StgEntCounter_link[__ptr__+OFFSET_StgEntCounter_link]
+oFFSET_StgEntCounter_entry_count :: Int
+oFFSET_StgEntCounter_entry_count = 20
+#define StgEntCounter_entry_count(__ptr__)  REP_StgEntCounter_entry_count[__ptr__+OFFSET_StgEntCounter_entry_count]
+sIZEOF_StgUpdateFrame_NoHdr :: Int
+sIZEOF_StgUpdateFrame_NoHdr = 4
+sIZEOF_StgCatchFrame_NoHdr :: Int
+sIZEOF_StgCatchFrame_NoHdr = 8
+sIZEOF_StgStopFrame_NoHdr :: Int
+sIZEOF_StgStopFrame_NoHdr = 0
+sIZEOF_StgMutArrPtrs_NoHdr :: Int
+sIZEOF_StgMutArrPtrs_NoHdr = 4
+oFFSET_StgMutArrPtrs_ptrs :: Int
+oFFSET_StgMutArrPtrs_ptrs = 0
+#define StgMutArrPtrs_ptrs(__ptr__)  REP_StgMutArrPtrs_ptrs[__ptr__+SIZEOF_StgHeader+OFFSET_StgMutArrPtrs_ptrs]
+sIZEOF_StgArrWords_NoHdr :: Int
+sIZEOF_StgArrWords_NoHdr = 4
+oFFSET_StgArrWords_words :: Int
+oFFSET_StgArrWords_words = 0
+#define StgArrWords_words(__ptr__)  REP_StgArrWords_words[__ptr__+SIZEOF_StgHeader+OFFSET_StgArrWords_words]
+oFFSET_StgArrWords_payload :: Int
+oFFSET_StgArrWords_payload = 4
+#define StgArrWords_payload(__ptr__,__ix__)  W_[__ptr__+SIZEOF_StgHeader+OFFSET_StgArrWords_payload + WDS(__ix__)]
+oFFSET_StgTSO__link :: Int
+oFFSET_StgTSO__link = 0
+#define StgTSO__link(__ptr__)  REP_StgTSO__link[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO__link]
+oFFSET_StgTSO_global_link :: Int
+oFFSET_StgTSO_global_link = 4
+#define StgTSO_global_link(__ptr__)  REP_StgTSO_global_link[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_global_link]
+oFFSET_StgTSO_what_next :: Int
+oFFSET_StgTSO_what_next = 8
+#define StgTSO_what_next(__ptr__)  REP_StgTSO_what_next[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_what_next]
+oFFSET_StgTSO_why_blocked :: Int
+oFFSET_StgTSO_why_blocked = 10
+#define StgTSO_why_blocked(__ptr__)  REP_StgTSO_why_blocked[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_why_blocked]
+oFFSET_StgTSO_block_info :: Int
+oFFSET_StgTSO_block_info = 16
+#define StgTSO_block_info(__ptr__)  REP_StgTSO_block_info[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_block_info]
+oFFSET_StgTSO_blocked_exceptions :: Int
+oFFSET_StgTSO_blocked_exceptions = 40
+#define StgTSO_blocked_exceptions(__ptr__)  REP_StgTSO_blocked_exceptions[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_blocked_exceptions]
+oFFSET_StgTSO_id :: Int
+oFFSET_StgTSO_id = 20
+#define StgTSO_id(__ptr__)  REP_StgTSO_id[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_id]
+oFFSET_StgTSO_cap :: Int
+oFFSET_StgTSO_cap = 32
+#define StgTSO_cap(__ptr__)  REP_StgTSO_cap[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_cap]
+oFFSET_StgTSO_saved_errno :: Int
+oFFSET_StgTSO_saved_errno = 24
+#define StgTSO_saved_errno(__ptr__)  REP_StgTSO_saved_errno[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_saved_errno]
+oFFSET_StgTSO_trec :: Int
+oFFSET_StgTSO_trec = 36
+#define StgTSO_trec(__ptr__)  REP_StgTSO_trec[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_trec]
+oFFSET_StgTSO_flags :: Int
+oFFSET_StgTSO_flags = 12
+#define StgTSO_flags(__ptr__)  REP_StgTSO_flags[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_flags]
+oFFSET_StgTSO_CCCS :: Int
+oFFSET_StgTSO_CCCS = 44
+#define StgTSO_CCCS(__ptr__)  REP_StgTSO_CCCS[__ptr__+SIZEOF_StgHeader+OFFSET_StgTSO_CCCS]
+oFFSET_StgTSO_sp :: Int
+oFFSET_StgTSO_sp = 52
+#define TSO_OFFSET_StgTSO_sp (SIZEOF_StgHeader+SIZEOF_OPT_StgTSOProfInfo+SIZEOF_OPT_StgTSOParInfo+SIZEOF_OPT_StgTSOGranInfo+SIZEOF_OPT_StgTSODistInfo+OFFSET_StgTSO_sp)
+#define StgTSO_sp(__ptr__)  REP_StgTSO_sp[__ptr__+TSO_OFFSET_StgTSO_sp]
+oFFSET_StgTSO_stack :: Int
+oFFSET_StgTSO_stack = 56
+#define TSO_OFFSET_StgTSO_stack (SIZEOF_StgHeader+SIZEOF_OPT_StgTSOProfInfo+SIZEOF_OPT_StgTSOParInfo+SIZEOF_OPT_StgTSOGranInfo+SIZEOF_OPT_StgTSODistInfo+OFFSET_StgTSO_stack)
+oFFSET_StgTSO_stack_size :: Int
+oFFSET_StgTSO_stack_size = 44
+#define TSO_OFFSET_StgTSO_stack_size (SIZEOF_StgHeader+SIZEOF_OPT_StgTSOProfInfo+SIZEOF_OPT_StgTSOParInfo+SIZEOF_OPT_StgTSOGranInfo+SIZEOF_OPT_StgTSODistInfo+OFFSET_StgTSO_stack_size)
+#define StgTSO_stack_size(__ptr__)  REP_StgTSO_stack_size[__ptr__+TSO_OFFSET_StgTSO_stack_size]
+sIZEOF_StgTSOProfInfo :: Int
+sIZEOF_StgTSOProfInfo = 4
+sIZEOF_StgTSOParInfo :: Int
+sIZEOF_StgTSOParInfo = 92
+sIZEOF_StgTSOGranInfo :: Int
+sIZEOF_StgTSOGranInfo = 92
+sIZEOF_StgTSODistInfo :: Int
+sIZEOF_StgTSODistInfo = 12
+#ifdef PROFILING
+#define SIZEOF_OPT_StgTSOProfInfo SIZEOF_StgTSOProfInfo
+#else
+#define SIZEOF_OPT_StgTSOProfInfo 0
+#endif
+
+#ifdef PAR
+#define SIZEOF_OPT_StgTSOParInfo SIZEOF_StgTSOParInfo
+#else
+#define SIZEOF_OPT_StgTSOParInfo 0
+#endif
+
+#ifdef GRAN
+#define SIZEOF_OPT_StgTSOGranInfo SIZEOF_StgTSOGranInfo
+#else
+#define SIZEOF_OPT_StgTSOGranInfo 0
+#endif
+
+#ifdef DIST
+#define SIZEOF_OPT_StgTSODistInfo SIZEOF_StgTSODistInfo
+#else
+#define SIZEOF_OPT_StgTSODistInfo 0
+#endif
+
+oFFSET_StgUpdateFrame_updatee :: Int
+oFFSET_StgUpdateFrame_updatee = 0
+#define StgUpdateFrame_updatee(__ptr__)  REP_StgUpdateFrame_updatee[__ptr__+SIZEOF_StgHeader+OFFSET_StgUpdateFrame_updatee]
+oFFSET_StgCatchFrame_handler :: Int
+oFFSET_StgCatchFrame_handler = 4
+#define StgCatchFrame_handler(__ptr__)  REP_StgCatchFrame_handler[__ptr__+SIZEOF_StgHeader+OFFSET_StgCatchFrame_handler]
+oFFSET_StgCatchFrame_exceptions_blocked :: Int
+oFFSET_StgCatchFrame_exceptions_blocked = 0
+#define StgCatchFrame_exceptions_blocked(__ptr__)  REP_StgCatchFrame_exceptions_blocked[__ptr__+SIZEOF_StgHeader+OFFSET_StgCatchFrame_exceptions_blocked]
+sIZEOF_StgPAP_NoHdr :: Int
+sIZEOF_StgPAP_NoHdr = 8
+oFFSET_StgPAP_n_args :: Int
+oFFSET_StgPAP_n_args = 2
+#define StgPAP_n_args(__ptr__)  REP_StgPAP_n_args[__ptr__+SIZEOF_StgHeader+OFFSET_StgPAP_n_args]
+oFFSET_StgPAP_fun :: Int
+oFFSET_StgPAP_fun = 4
+#define StgPAP_fun(__ptr__)  REP_StgPAP_fun[__ptr__+SIZEOF_StgHeader+OFFSET_StgPAP_fun]
+oFFSET_StgPAP_arity :: Int
+oFFSET_StgPAP_arity = 0
+#define StgPAP_arity(__ptr__)  REP_StgPAP_arity[__ptr__+SIZEOF_StgHeader+OFFSET_StgPAP_arity]
+oFFSET_StgPAP_payload :: Int
+oFFSET_StgPAP_payload = 8
+#define StgPAP_payload(__ptr__,__ix__)  W_[__ptr__+SIZEOF_StgHeader+OFFSET_StgPAP_payload + WDS(__ix__)]
+sIZEOF_StgAP_NoThunkHdr :: Int
+sIZEOF_StgAP_NoThunkHdr = 8
+sIZEOF_StgAP_NoHdr :: Int
+sIZEOF_StgAP_NoHdr = 12
+oFFSET_StgAP_n_args :: Int
+oFFSET_StgAP_n_args = 6
+#define StgAP_n_args(__ptr__)  REP_StgAP_n_args[__ptr__+SIZEOF_StgHeader+OFFSET_StgAP_n_args]
+oFFSET_StgAP_fun :: Int
+oFFSET_StgAP_fun = 8
+#define StgAP_fun(__ptr__)  REP_StgAP_fun[__ptr__+SIZEOF_StgHeader+OFFSET_StgAP_fun]
+oFFSET_StgAP_payload :: Int
+oFFSET_StgAP_payload = 12
+#define StgAP_payload(__ptr__,__ix__)  W_[__ptr__+SIZEOF_StgHeader+OFFSET_StgAP_payload + WDS(__ix__)]
+sIZEOF_StgAP_STACK_NoThunkHdr :: Int
+sIZEOF_StgAP_STACK_NoThunkHdr = 8
+sIZEOF_StgAP_STACK_NoHdr :: Int
+sIZEOF_StgAP_STACK_NoHdr = 12
+oFFSET_StgAP_STACK_size :: Int
+oFFSET_StgAP_STACK_size = 4
+#define StgAP_STACK_size(__ptr__)  REP_StgAP_STACK_size[__ptr__+SIZEOF_StgHeader+OFFSET_StgAP_STACK_size]
+oFFSET_StgAP_STACK_fun :: Int
+oFFSET_StgAP_STACK_fun = 8
+#define StgAP_STACK_fun(__ptr__)  REP_StgAP_STACK_fun[__ptr__+SIZEOF_StgHeader+OFFSET_StgAP_STACK_fun]
+oFFSET_StgAP_STACK_payload :: Int
+oFFSET_StgAP_STACK_payload = 12
+#define StgAP_STACK_payload(__ptr__,__ix__)  W_[__ptr__+SIZEOF_StgHeader+OFFSET_StgAP_STACK_payload + WDS(__ix__)]
+sIZEOF_StgSelector_NoThunkHdr :: Int
+sIZEOF_StgSelector_NoThunkHdr = 4
+sIZEOF_StgSelector_NoHdr :: Int
+sIZEOF_StgSelector_NoHdr = 8
+oFFSET_StgInd_indirectee :: Int
+oFFSET_StgInd_indirectee = 0
+#define StgInd_indirectee(__ptr__)  REP_StgInd_indirectee[__ptr__+SIZEOF_StgHeader+OFFSET_StgInd_indirectee]
+sIZEOF_StgMutVar_NoHdr :: Int
+sIZEOF_StgMutVar_NoHdr = 4
+oFFSET_StgMutVar_var :: Int
+oFFSET_StgMutVar_var = 0
+#define StgMutVar_var(__ptr__)  REP_StgMutVar_var[__ptr__+SIZEOF_StgHeader+OFFSET_StgMutVar_var]
+sIZEOF_StgAtomicallyFrame_NoHdr :: Int
+sIZEOF_StgAtomicallyFrame_NoHdr = 8
+oFFSET_StgAtomicallyFrame_code :: Int
+oFFSET_StgAtomicallyFrame_code = 0
+#define StgAtomicallyFrame_code(__ptr__)  REP_StgAtomicallyFrame_code[__ptr__+SIZEOF_StgHeader+OFFSET_StgAtomicallyFrame_code]
+oFFSET_StgAtomicallyFrame_next_invariant_to_check :: Int
+oFFSET_StgAtomicallyFrame_next_invariant_to_check = 4
+#define StgAtomicallyFrame_next_invariant_to_check(__ptr__)  REP_StgAtomicallyFrame_next_invariant_to_check[__ptr__+SIZEOF_StgHeader+OFFSET_StgAtomicallyFrame_next_invariant_to_check]
+oFFSET_StgInvariantCheckQueue_invariant :: Int
+oFFSET_StgInvariantCheckQueue_invariant = 0
+#define StgInvariantCheckQueue_invariant(__ptr__)  REP_StgInvariantCheckQueue_invariant[__ptr__+SIZEOF_StgHeader+OFFSET_StgInvariantCheckQueue_invariant]
+oFFSET_StgInvariantCheckQueue_my_execution :: Int
+oFFSET_StgInvariantCheckQueue_my_execution = 4
+#define StgInvariantCheckQueue_my_execution(__ptr__)  REP_StgInvariantCheckQueue_my_execution[__ptr__+SIZEOF_StgHeader+OFFSET_StgInvariantCheckQueue_my_execution]
+oFFSET_StgInvariantCheckQueue_next_queue_entry :: Int
+oFFSET_StgInvariantCheckQueue_next_queue_entry = 8
+#define StgInvariantCheckQueue_next_queue_entry(__ptr__)  REP_StgInvariantCheckQueue_next_queue_entry[__ptr__+SIZEOF_StgHeader+OFFSET_StgInvariantCheckQueue_next_queue_entry]
+oFFSET_StgAtomicInvariant_code :: Int
+oFFSET_StgAtomicInvariant_code = 0
+#define StgAtomicInvariant_code(__ptr__)  REP_StgAtomicInvariant_code[__ptr__+SIZEOF_StgHeader+OFFSET_StgAtomicInvariant_code]
+sIZEOF_StgCatchSTMFrame_NoHdr :: Int
+sIZEOF_StgCatchSTMFrame_NoHdr = 8
+oFFSET_StgCatchSTMFrame_handler :: Int
+oFFSET_StgCatchSTMFrame_handler = 4
+#define StgCatchSTMFrame_handler(__ptr__)  REP_StgCatchSTMFrame_handler[__ptr__+SIZEOF_StgHeader+OFFSET_StgCatchSTMFrame_handler]
+oFFSET_StgCatchSTMFrame_code :: Int
+oFFSET_StgCatchSTMFrame_code = 0
+#define StgCatchSTMFrame_code(__ptr__)  REP_StgCatchSTMFrame_code[__ptr__+SIZEOF_StgHeader+OFFSET_StgCatchSTMFrame_code]
+sIZEOF_StgCatchRetryFrame_NoHdr :: Int
+sIZEOF_StgCatchRetryFrame_NoHdr = 12
+oFFSET_StgCatchRetryFrame_running_alt_code :: Int
+oFFSET_StgCatchRetryFrame_running_alt_code = 0
+#define StgCatchRetryFrame_running_alt_code(__ptr__)  REP_StgCatchRetryFrame_running_alt_code[__ptr__+SIZEOF_StgHeader+OFFSET_StgCatchRetryFrame_running_alt_code]
+oFFSET_StgCatchRetryFrame_first_code :: Int
+oFFSET_StgCatchRetryFrame_first_code = 4
+#define StgCatchRetryFrame_first_code(__ptr__)  REP_StgCatchRetryFrame_first_code[__ptr__+SIZEOF_StgHeader+OFFSET_StgCatchRetryFrame_first_code]
+oFFSET_StgCatchRetryFrame_alt_code :: Int
+oFFSET_StgCatchRetryFrame_alt_code = 8
+#define StgCatchRetryFrame_alt_code(__ptr__)  REP_StgCatchRetryFrame_alt_code[__ptr__+SIZEOF_StgHeader+OFFSET_StgCatchRetryFrame_alt_code]
+oFFSET_StgTVarWatchQueue_closure :: Int
+oFFSET_StgTVarWatchQueue_closure = 0
+#define StgTVarWatchQueue_closure(__ptr__)  REP_StgTVarWatchQueue_closure[__ptr__+SIZEOF_StgHeader+OFFSET_StgTVarWatchQueue_closure]
+oFFSET_StgTVarWatchQueue_next_queue_entry :: Int
+oFFSET_StgTVarWatchQueue_next_queue_entry = 4
+#define StgTVarWatchQueue_next_queue_entry(__ptr__)  REP_StgTVarWatchQueue_next_queue_entry[__ptr__+SIZEOF_StgHeader+OFFSET_StgTVarWatchQueue_next_queue_entry]
+oFFSET_StgTVarWatchQueue_prev_queue_entry :: Int
+oFFSET_StgTVarWatchQueue_prev_queue_entry = 8
+#define StgTVarWatchQueue_prev_queue_entry(__ptr__)  REP_StgTVarWatchQueue_prev_queue_entry[__ptr__+SIZEOF_StgHeader+OFFSET_StgTVarWatchQueue_prev_queue_entry]
+sIZEOF_StgWeak_NoHdr :: Int
+sIZEOF_StgWeak_NoHdr = 20
+oFFSET_StgWeak_link :: Int
+oFFSET_StgWeak_link = 16
+#define StgWeak_link(__ptr__)  REP_StgWeak_link[__ptr__+SIZEOF_StgHeader+OFFSET_StgWeak_link]
+oFFSET_StgWeak_key :: Int
+oFFSET_StgWeak_key = 4
+#define StgWeak_key(__ptr__)  REP_StgWeak_key[__ptr__+SIZEOF_StgHeader+OFFSET_StgWeak_key]
+oFFSET_StgWeak_value :: Int
+oFFSET_StgWeak_value = 8
+#define StgWeak_value(__ptr__)  REP_StgWeak_value[__ptr__+SIZEOF_StgHeader+OFFSET_StgWeak_value]
+oFFSET_StgWeak_finalizer :: Int
+oFFSET_StgWeak_finalizer = 12
+#define StgWeak_finalizer(__ptr__)  REP_StgWeak_finalizer[__ptr__+SIZEOF_StgHeader+OFFSET_StgWeak_finalizer]
+oFFSET_StgWeak_cfinalizer :: Int
+oFFSET_StgWeak_cfinalizer = 0
+#define StgWeak_cfinalizer(__ptr__)  REP_StgWeak_cfinalizer[__ptr__+SIZEOF_StgHeader+OFFSET_StgWeak_cfinalizer]
+sIZEOF_StgDeadWeak_NoHdr :: Int
+sIZEOF_StgDeadWeak_NoHdr = 4
+oFFSET_StgDeadWeak_link :: Int
+oFFSET_StgDeadWeak_link = 0
+#define StgDeadWeak_link(__ptr__)  REP_StgDeadWeak_link[__ptr__+SIZEOF_StgHeader+OFFSET_StgDeadWeak_link]
+sIZEOF_StgMVar_NoHdr :: Int
+sIZEOF_StgMVar_NoHdr = 12
+oFFSET_StgMVar_head :: Int
+oFFSET_StgMVar_head = 0
+#define StgMVar_head(__ptr__)  REP_StgMVar_head[__ptr__+SIZEOF_StgHeader+OFFSET_StgMVar_head]
+oFFSET_StgMVar_tail :: Int
+oFFSET_StgMVar_tail = 4
+#define StgMVar_tail(__ptr__)  REP_StgMVar_tail[__ptr__+SIZEOF_StgHeader+OFFSET_StgMVar_tail]
+oFFSET_StgMVar_value :: Int
+oFFSET_StgMVar_value = 8
+#define StgMVar_value(__ptr__)  REP_StgMVar_value[__ptr__+SIZEOF_StgHeader+OFFSET_StgMVar_value]
+sIZEOF_StgBCO_NoHdr :: Int
+sIZEOF_StgBCO_NoHdr = 16
+oFFSET_StgBCO_instrs :: Int
+oFFSET_StgBCO_instrs = 0
+#define StgBCO_instrs(__ptr__)  REP_StgBCO_instrs[__ptr__+SIZEOF_StgHeader+OFFSET_StgBCO_instrs]
+oFFSET_StgBCO_literals :: Int
+oFFSET_StgBCO_literals = 4
+#define StgBCO_literals(__ptr__)  REP_StgBCO_literals[__ptr__+SIZEOF_StgHeader+OFFSET_StgBCO_literals]
+oFFSET_StgBCO_ptrs :: Int
+oFFSET_StgBCO_ptrs = 8
+#define StgBCO_ptrs(__ptr__)  REP_StgBCO_ptrs[__ptr__+SIZEOF_StgHeader+OFFSET_StgBCO_ptrs]
+oFFSET_StgBCO_arity :: Int
+oFFSET_StgBCO_arity = 12
+#define StgBCO_arity(__ptr__)  REP_StgBCO_arity[__ptr__+SIZEOF_StgHeader+OFFSET_StgBCO_arity]
+oFFSET_StgBCO_size :: Int
+oFFSET_StgBCO_size = 14
+#define StgBCO_size(__ptr__)  REP_StgBCO_size[__ptr__+SIZEOF_StgHeader+OFFSET_StgBCO_size]
+oFFSET_StgBCO_bitmap :: Int
+oFFSET_StgBCO_bitmap = 16
+#define StgBCO_bitmap(__ptr__,__ix__)  W_[__ptr__+SIZEOF_StgHeader+OFFSET_StgBCO_bitmap + WDS(__ix__)]
+sIZEOF_StgStableName_NoHdr :: Int
+sIZEOF_StgStableName_NoHdr = 4
+oFFSET_StgStableName_sn :: Int
+oFFSET_StgStableName_sn = 0
+#define StgStableName_sn(__ptr__)  REP_StgStableName_sn[__ptr__+SIZEOF_StgHeader+OFFSET_StgStableName_sn]
+oFFSET_RtsFlags_ProfFlags_showCCSOnException :: Int
+oFFSET_RtsFlags_ProfFlags_showCCSOnException = 208
+#define RtsFlags_ProfFlags_showCCSOnException(__ptr__)  REP_RtsFlags_ProfFlags_showCCSOnException[__ptr__+OFFSET_RtsFlags_ProfFlags_showCCSOnException]
+oFFSET_RtsFlags_DebugFlags_apply :: Int
+oFFSET_RtsFlags_DebugFlags_apply = 164
+#define RtsFlags_DebugFlags_apply(__ptr__)  REP_RtsFlags_DebugFlags_apply[__ptr__+OFFSET_RtsFlags_DebugFlags_apply]
+oFFSET_RtsFlags_DebugFlags_sanity :: Int
+oFFSET_RtsFlags_DebugFlags_sanity = 140
+#define RtsFlags_DebugFlags_sanity(__ptr__)  REP_RtsFlags_DebugFlags_sanity[__ptr__+OFFSET_RtsFlags_DebugFlags_sanity]
+oFFSET_RtsFlags_DebugFlags_weak :: Int
+oFFSET_RtsFlags_DebugFlags_weak = 124
+#define RtsFlags_DebugFlags_weak(__ptr__)  REP_RtsFlags_DebugFlags_weak[__ptr__+OFFSET_RtsFlags_DebugFlags_weak]
+oFFSET_RtsFlags_GcFlags_initialStkSize :: Int
+oFFSET_RtsFlags_GcFlags_initialStkSize = 12
+#define RtsFlags_GcFlags_initialStkSize(__ptr__)  REP_RtsFlags_GcFlags_initialStkSize[__ptr__+OFFSET_RtsFlags_GcFlags_initialStkSize]
+oFFSET_RtsFlags_MiscFlags_tickInterval :: Int
+oFFSET_RtsFlags_MiscFlags_tickInterval = 100
+#define RtsFlags_MiscFlags_tickInterval(__ptr__)  REP_RtsFlags_MiscFlags_tickInterval[__ptr__+OFFSET_RtsFlags_MiscFlags_tickInterval]
+sIZEOF_StgFunInfoExtraFwd :: Int
+sIZEOF_StgFunInfoExtraFwd = 16
+oFFSET_StgFunInfoExtraFwd_slow_apply :: Int
+oFFSET_StgFunInfoExtraFwd_slow_apply = 12
+#define StgFunInfoExtraFwd_slow_apply(__ptr__)  REP_StgFunInfoExtraFwd_slow_apply[__ptr__+OFFSET_StgFunInfoExtraFwd_slow_apply]
+oFFSET_StgFunInfoExtraFwd_fun_type :: Int
+oFFSET_StgFunInfoExtraFwd_fun_type = 0
+#define StgFunInfoExtraFwd_fun_type(__ptr__)  REP_StgFunInfoExtraFwd_fun_type[__ptr__+OFFSET_StgFunInfoExtraFwd_fun_type]
+oFFSET_StgFunInfoExtraFwd_arity :: Int
+oFFSET_StgFunInfoExtraFwd_arity = 2
+#define StgFunInfoExtraFwd_arity(__ptr__)  REP_StgFunInfoExtraFwd_arity[__ptr__+OFFSET_StgFunInfoExtraFwd_arity]
+oFFSET_StgFunInfoExtraFwd_bitmap :: Int
+oFFSET_StgFunInfoExtraFwd_bitmap = 8
+#define StgFunInfoExtraFwd_bitmap(__ptr__)  REP_StgFunInfoExtraFwd_bitmap[__ptr__+OFFSET_StgFunInfoExtraFwd_bitmap]
+sIZEOF_StgFunInfoExtraRev :: Int
+sIZEOF_StgFunInfoExtraRev = 16
+oFFSET_StgFunInfoExtraRev_slow_apply_offset :: Int
+oFFSET_StgFunInfoExtraRev_slow_apply_offset = 0
+#define StgFunInfoExtraRev_slow_apply_offset(__ptr__)  REP_StgFunInfoExtraRev_slow_apply_offset[__ptr__+OFFSET_StgFunInfoExtraRev_slow_apply_offset]
+oFFSET_StgFunInfoExtraRev_fun_type :: Int
+oFFSET_StgFunInfoExtraRev_fun_type = 12
+#define StgFunInfoExtraRev_fun_type(__ptr__)  REP_StgFunInfoExtraRev_fun_type[__ptr__+OFFSET_StgFunInfoExtraRev_fun_type]
+oFFSET_StgFunInfoExtraRev_arity :: Int
+oFFSET_StgFunInfoExtraRev_arity = 14
+#define StgFunInfoExtraRev_arity(__ptr__)  REP_StgFunInfoExtraRev_arity[__ptr__+OFFSET_StgFunInfoExtraRev_arity]
+oFFSET_StgFunInfoExtraRev_bitmap :: Int
+oFFSET_StgFunInfoExtraRev_bitmap = 4
+#define StgFunInfoExtraRev_bitmap(__ptr__)  REP_StgFunInfoExtraRev_bitmap[__ptr__+OFFSET_StgFunInfoExtraRev_bitmap]
+oFFSET_StgLargeBitmap_size :: Int
+oFFSET_StgLargeBitmap_size = 0
+#define StgLargeBitmap_size(__ptr__)  REP_StgLargeBitmap_size[__ptr__+OFFSET_StgLargeBitmap_size]
+oFFSET_StgLargeBitmap_bitmap :: Int
+oFFSET_StgLargeBitmap_bitmap = 4
+sIZEOF_snEntry :: Int
+sIZEOF_snEntry = 16
+oFFSET_snEntry_sn_obj :: Int
+oFFSET_snEntry_sn_obj = 12
+#define snEntry_sn_obj(__ptr__)  REP_snEntry_sn_obj[__ptr__+OFFSET_snEntry_sn_obj]
+oFFSET_snEntry_addr :: Int
+oFFSET_snEntry_addr = 0
+#define snEntry_addr(__ptr__)  REP_snEntry_addr[__ptr__+OFFSET_snEntry_addr]
+sIZEOF_MP_INT :: Int
+sIZEOF_MP_INT = 12
+oFFSET_MP_INT__mp_alloc :: Int
+oFFSET_MP_INT__mp_alloc = 0
+#define MP_INT__mp_alloc(__ptr__)  REP_MP_INT__mp_alloc[__ptr__+OFFSET_MP_INT__mp_alloc]
+oFFSET_MP_INT__mp_size :: Int
+oFFSET_MP_INT__mp_size = 4
+#define MP_INT__mp_size(__ptr__)  REP_MP_INT__mp_size[__ptr__+OFFSET_MP_INT__mp_size]
+oFFSET_MP_INT__mp_d :: Int
+oFFSET_MP_INT__mp_d = 8
+#define MP_INT__mp_d(__ptr__)  REP_MP_INT__mp_d[__ptr__+OFFSET_MP_INT__mp_d]

